#!/bin/ksh

# Skript controls the calls of the seperate scritpts upon event flags
# Setting directories for skripts jobs and flags
cd `dirname $0`
SCRIPTDIR=`pwd`
FLAGDIR=${SCRIPTDIR}/flags
JOBDIR=$SCRIPTDIR/jobs

	rm -rf $FLAGDIR/receivedcondition.txt
cd $FLAGDIR
	ls *_FINISHED > $FLAGDIR/receivedcondition.txt
	touch $FLAGDIR/processedcondition.txt
cd $SCRIPTDIR
	originalnextcondition=`diff $FLAGDIR/receivedcondition.txt $FLAGDIR/processedcondition.txt | grep "^<"| sed "s/< //" |head -1 `
	nextcondition=`basename $originalnextcondition |cut -d"_" -f1`
	if [ "X$nextcondition" == "X." ]  
	then 
		exit 0
	fi
	echo $originalnextcondition >> $FLAGDIR/processedcondition.txt
	dependendlist=`grep "^$nextcondition" ${SCRIPTDIR}/conditionfile.txt |nawk ' { system(" echo "$2); }'|sort|uniq`
	for dependend in $dependendlist
	do
		conditionlist=`grep "${dependend}$" ${SCRIPTDIR}/conditionfile.txt |nawk ' { system(" echo "$1); }'|sort|uniq`
		allconditionsset=true
		for condition in $conditionlist
		do
			test -f $FLAGDIR/${condition}_FINISHED || allconditionsset=false;
		done 
		#falls bedingungen erfllt sind  started flag gesetzt und der jobwrapper dafr im hintergrund gestartet.
		if [ "$allconditionsset" == "true" ]; then 
			if [ ! -f $FLAGDIR/${dependend}_STARTED ]; then 
				touch $FLAGDIR/${dependend}_STARTED
				${SCRIPTDIR}/jobwrapper.sh ${JOBDIR}/${dependend} &
			fi
		fi
	done


